/*
 * Copyright (C) 2003 Kristoffer Vinther.
 * For contact information, please visit
 * http://www.brics.dk/~kv/thesis/.
 * If you use this code in commercial applications, please notify me.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the
 * Free Software Foundation, Inc.
 * 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifdef WIN32
#include "../ansiwin.h"

#else // WIN32

#define _FILE_OFFSET_BITS 64
#include <sys/types.h>

//#include <stdio.h>
//#include <malloc.h>
//#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>
#include <pthread.h>
#include <semaphore.h>
#ifndef O_LARGEFILE
#define O_LARGEFILE 0100000
#endif // O_LARGEFILE
#define __w64
#endif // WIN32

#ifdef _MT
#ifdef WIN32
/*#define DECLARE_MUTEX(M) HANDLE M
#define INIT_MUTEX(M) M = CreateMutex(NULL, FALSE, NULL);
#define LOCK_MUTEX(M) WaitForSingleObject(M, INFINITE)
#define UNLOCK_MUTEX(M) ReleaseMutex(M)
#define CLEANUP_MUTEX(M) CloseHandle(M)*/
#define MUTEX LPCRITICAL_SECTION
#define DECLARE_MUTEX(M) LPCRITICAL_SECTION M;
#define INIT_MUTEX(M) { M = (LPCRITICAL_SECTION)malloc(sizeof(CRITICAL_SECTION)); InitializeCriticalSection(M); }
#define LOCK_MUTEX(M) EnterCriticalSection(M)
#define UNLOCK_MUTEX(M) LeaveCriticalSection(M)
#define CLEANUP_MUTEX(M) { DeleteCriticalSection(M); free(M); }
#else // not WIN32
#define MUTEX pthread_mutex_t*
#define DECLARE_MUTEX(M) pthread_mutex_t* M;
#define INIT_MUTEX(M) { M = (pthread_mutex_t*)malloc(sizeof(pthread_mutex_t)); pthread_mutex_init(M, NULL); pthread_mutex_lock(M); }
#define LOCK_MUTEX(M) pthread_mutex_lock(M)
#define UNLOCK_MUTEX(M) pthread_mutex_unlock(M)
#define CLEANUP_MUTEX(M) { pthread_mutex_destroy(M); free(M); }
#endif // WIN32
#define COPY_MUTEX(M1, M2) M1 = M2
#else // not _MT
#define DECLARE_MUTEX(M)
#define INIT_MUTEX(M)
#define LOCK_MUTEX(M)
#define UNLOCK_MUTEX(M)
#define CLEANUP_MUTEX(M)
#define COPY_MUTEX(M1, M2)
#endif // _MT

#include "int64.h"
