/*
 * Copyright (C) 2003 Kristoffer Vinther.
 * For contact information, please visit
 * http://www.brics.dk/~kv/thesis/.
 * If you use this code in commercial applications, please notify me.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the
 * Free Software Foundation, Inc.
 * 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <iostream>
#include <stdlib.h>

void exit_usage()
{
	std::cerr << "fillmem RAM_size_in_MB" << std::endl;
	exit(1);
}

int main(int argc, char *argv[])
{
	if( argc != 2 )
		exit_usage();
	unsigned long size = atoi(argv[1])*1024*1024;
	long *A = new long[size/sizeof(long)];
	A[0] = rand();
	A[1] = rand();
	for( unsigned long i=2; i!=size/sizeof(long); ++i )
	A[i] = 2*A[i-2]-A[i-1];
	return A[size/sizeof(long)-1] - A[rand() % size/sizeof(long)];
}
