/*
 * Copyright (C) 2003 Kristoffer Vinther.
 * For contact information, please visit
 * http://www.brics.dk/~kv/thesis/.
 * If you use this code in commercial applications, please notify me.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the
 * Free Software Foundation, Inc.
 * 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __LAYOUTMANAGER_H_INCLUDED_
#define __LAYOUTMANAGER_H_INCLUDED_

#include <malloc.h>

bool __lm_messuring;
bool __lm_size;

template<class Controller>
class LayoutManager
{
public:
	LayoutManager(size_t size)
	{
		__lm_messuring = true;
		__lm_size = 0;
		Controller::Layout(*this, size);
		__lm_messuring = false;
		mem = malloc(size);
		Controller::Layout(*this, size);
	}
	virtual ~LayoutManager()
	{
		free(mem);
	}

	void Layout(size_t size)
	{
		if( !__lm_messuring )
			;
	}
	void Allocate(size_t bytes)
	{
		if( __lm_messuring )
			__lm_size += bytes;
	}

	template<class T>
	T& get()
		{ return *(T*)mem; }

private:
	void* mem;
};

#endif // __LAYOUTMANAGER_H_INCLUDED_
