/*
 * Copyright (C) 2003 Kristoffer Vinther.
 * For contact information, please visit
 * http://www.brics.dk/~kv/thesis/.
 * If you use this code in commercial applications, please notify me.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the
 * Free Software Foundation, Inc.
 * 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef ___INT64_H_INCLUDED_
#define ___INT64_H_INCLUDED_

#ifdef _MSC_VER

typedef __int64 _int64_t;
typedef unsigned __int64 _uint64_t;
#define INT64_MAX 9223372036854775807
#define UINT64_MAX 18446744073709551615u

#else // _MSC_VER
#ifdef _MIPS_ISA

#include <sys/types.h>
typedef int64_t _int64_t;
typedef uint64_t _uint64_t;
#define INT64_MAX 9223372036854775807
#define UINT64_MAX 18446744073709551615u

#else // _MIPS_ISA

#ifdef WIN32
#include <stdint.h>
typedef int64_t _int64_t;
typedef uint64_t _uint64_t;
#else // WIN32
#include <sys/types.h>
typedef int64_t _int64_t;
typedef u_int64_t _uint64_t;
#endif // WIN32
#define INT64_MAX ((int64_t)(2147483647) << 32 + 4294967295u)
#define UINT64_MAX ((uint64_t)4294967295u << 32 + 4294967295u)

#endif // _MSC_VER
#endif // _MIPS_ISA

#endif // ___INT64_H_INCLUDED_
