
#include "../../Bench/aarray.h"
#include "../../Bench/elements.h"
#include "../../Bench/stopwatch.h"
#include <exception>
#include <iostream>
#define UNLIMITED_MERGER_OUTPUT
#include "../../Sort/Sort.h"
#include "../../Sort/funnel/layout_mveb.h"
#include "../../Sort/funnel/pointer_navigator.h"
#include "../../Sort/funnel/merge_tree.h"
#include "../../Sort/funnel/stack_allocator.h"

#ifdef WIN32
#define OUT_FILE "C:\\Documents and Settings\\kv\\Local Settings\\Temp\\sorted.img"
#else // WIN32

#ifndef IMAGEDIR
#define IMAGEDIR "/tmp/"
#endif // IMAGEDIR
#define OUT_FILE IMAGEDIR "sorted.img"

#endif // WIN32

void exit_usage()
{
	std::cerr << "ffunnelsort -e{i|p|r} input [output]" << std::endl;
	exit(1);
}

stopwatch w;
pf_counter pfc;
miss_counter mc;

template<class T>
void do_sort(const char *in, const char *out)
{
	using namespace funnel;
	typedef rec_merge_tree<T, buffer<T*>, mixed_veb_layout<pointer_flip_navigator<pointer_flip_node<4,T*>,splitter<4> >, splitter<4>, T, stack_allocator<T> >, four_merger<4, buffer<T*>, T> > merger;
	typename auto_array::map_array<T> A(in, auto_array::MAP_EXISTING | auto_array::MAP_READ | auto_array::MAP_WRITE);
	std::cout << "\t\t<size>" << A.end()-A.begin() << "</size>" << std::endl;
	if( out )
	{
//		typename auto_array::map_array<T> B(out, auto_array::MAP_CREATE | auto_array::MAP_READ | auto_array::MAP_WRITE, A.end()-A.begin());
		auto_array::binfile_ostream<T> B(out);
		pfc.start(); mc.start(); w.start();
		iosort::merge_sort<merger,splitter<4> >(A.begin(), A.end(), B.begin());
		w.stop(); mc.stop(); pfc.stop();
	}
	else
	{
		typename auto_array::map_array<T> B(OUT_FILE, auto_array::MAP_CREATE | auto_array::MAP_READ | auto_array::MAP_WRITE | auto_array::MAP_TEMPORARY | auto_array::MAP_STREAMING, A.end()-A.begin());
		pfc.start(); mc.start(); w.start();
		iosort::merge_sort<merger,splitter<4> >(A.begin(), A.end(), B.begin());
		std::copy(B.begin(), B.end(), A.begin());
		w.stop(); mc.stop(); pfc.stop();
	}
}

int main(int argc, char *argv[])
{
	if( argc < 3 || argc > 4 )
		exit_usage();
	if( argv[1][0] != '-' || argv[1][1] != 'e' )
		exit_usage();
	std::cout << "\t<run buildtime=\"" << sys_names::buildtime() << "\" compiler=\"" << sys_names::compiler() << "\" execstatus=\"0\">" << std::endl;
	std::cout << "\t\t<algorithm>ffunnelsort</algorithm>" << std::endl;
	try
	{
		switch( argv[1][2] )
		{
			case 'i':
				do_sort<int>(argv[2], argc==4? argv[3] : NULL);
				break;
			case 'p':
				do_sort<element>(argv[2], argc==4? argv[3] : NULL);
				break;
			case 'r':
				do_sort<record>(argv[2], argc==4? argv[3] : NULL);
				break;
			break;
		default:
			exit_usage();
		}
		std::cout << w.xmltag(2) << std::endl;
		std::cout << pfc.xmltag(2) << std::endl;
		std::cout << mc.xmltag(2) << std::endl;
	}
	catch( std::exception& ex )
	{
		std::cout << "\t\t<error>Caught std::exception: " << ex.what() << "</error>" << std::endl;
		return 1;
	}
	std::cout << "\t</run>" << std::endl;
	return 0;
}
