#ifndef __ELEMENTS_H_INCLUDED_
#define __ELEMENTS_H_INCLUDED_

#include <iostream.h>
#include <limits.h>

//template<class T>
//class factory;

class element
{
//	friend class factory<element>;
	friend ostream& operator<<(ostream& os, const element& e);
public:
	element() : key(), ptr() { };
	element(unsigned long int key, void* ptr) : key(key), ptr(ptr) { };
	inline bool operator<(const element& rhs) const
		{ return key<rhs.key; }
	inline bool operator>(const element& rhs) const
		{ return key>rhs.key; }
	inline bool operator!=(const element& rhs) const
		{ return key!=rhs.key; }
	inline bool operator==(const element& rhs) const
		{ return key==rhs.key; }

	inline element operator+=(const element& rhs)
		{ key+=rhs.key; return *this; }
private:
	unsigned long int key;
	void* ptr;
};
ostream& operator<<(ostream& os, const element& e)
{
	return os << '(' << e.key << ',' << e.ptr << ')';
}


#include <stdlib.h> // for strncmp

class record
{
//	friend class factory<record>;
	friend ostream& operator<<(ostream& os, const record& e);
public:
	inline bool operator<(const record& rhs) const
		{ return strncmp(rec,rhs.rec,record_size) < 0; }
	inline bool operator>(const record& rhs) const
		{ return strncmp(rec,rhs.rec,record_size) > 0; }
	inline bool operator!=(const record& rhs) const
		{ return strncmp(rec,rhs.rec,record_size) != 0; }
	inline bool operator==(const record& rhs) const
		{ return strncmp(rec,rhs.rec,record_size) == 0; }

	inline record operator+=(const record& rhs)
	{
		for( int i=0; i!=record_size; ++i )
			rec[i] += rhs.rec[i];
		return *this;
	}

	inline char& operator[](int i)
		{ return rec[i]; }
private:
	enum tag_size { record_size = 100 };
	char rec[record_size];
};
ostream& operator<<(ostream& os, const record& e)
{
	os << '[';
	for( int i=0; i!=record::record_size; ++i )
		os << e.rec[i];
	return os << ']';
}

#include <math.h>
/*
template<class T>
class factory
{
public:
	inline static T from_scalar(double d)
	{
//		if( d < 0.0 || d > 1.0 )
//			throw invalid_argument("scalar must be positive and less than one");
		return static_cast<T>(d*(numeric_limits<T>::max()-numeric_limits<T>::min()))+numeric_limits<T>::min();
	}
	inline static void increment(T& t)
		{ ++t; }
};

template<>
class factory<element>
{
public:
	inline static element from_scalar(double d)
		{ return element(factory<unsigned long int>::from_scalar(d), static_cast<char*>(NULL)+0xBAADF00D); }
	inline static void increment(element& t)
		{ ++t.key; }
};

template<>
class factory<record>
{
public:
	inline static record from_scalar(double d)
	{
		record ret;
//		if( d < 0.0 || d > 1.0 )
//			throw invalid_argument("scalar must be positive and less than one");
		for( int i=0; i!=record::record_size; ++i )
		{
			d *= numeric_limits<char>::max()-numeric_limits<char>::min();
			ret.rec[i] = static_cast<char>(d+numeric_limits<char>::min());
			d -= floor(d);
		}
		return ret;
	}
	inline static void increment(record& t)
	{
		int i = record::record_size-1;
		for( ++t.rec[i]; t.rec[i]==numeric_limits<char>::min() && i; --i );
	}
};
*/
#endif // __ELEMENTS_H_INCLUDED_
