#ifndef __INT64_H_INCLUDED_
#define __INT64_H_INCLUDED_

#ifdef _MSC_VER

typedef __int64 int64_t;
typedef unsigned __int64 uint64_t;
#define INT64_MAX 9223372036854775807
#define UINT64_MAX 18446744073709551615u

#else // _MSC_VER
#ifdef _MIPS_ISA

#include <sys/types.h>
typedef int64_t int64_t;
typedef uint64_t uint64_t;
#define INT64_MAX 9223372036854775807
#define UINT64_MAX 18446744073709551615u

#else // _MIPS_ISA

#ifdef WIN32
#include <stdint.h>
typedef int64_t int64_t;
typedef uint64_t uint64_t;
#else // WIN32
#include <sys/types.h>
typedef int64_t int64_t;
typedef u_int64_t uint64_t;
#endif // WIN32
#define INT64_MAX ((int64_t)(2147483647) << 32 + 4294967295u)
#define UINT64_MAX ((uint64_t)4294967295u << 32 + 4294967295u)

#endif // _MSC_VER
#endif // _MIPS_ISA

#endif // __INT64_H_INCLUDED_
